#! /bin/sh
file="/etc/apt/sources.list.d/cdos-appstore.list"
curdir=$(dirname $(readlink -f $0))
confile="${curdir}/ServerConfig.ini"

get_repourl() {
  local filename="$1"
  repoUrl=$(grep "^repoUrl" $filename | cut -d'=' -f2)
  if [ -z $repoUrl ]; then
    repoUrl=$(grep "^onlineUrl" $filename | cut -d'=' -f2)
  fi
}

getRepobyVer() {
    local ver=$(cat /etc/os-release | grep -E '^VERSION=' | cut -d '=' -f2)
    ver=$(eval echo $ver)
    ver=$(echo $ver | cut -d '-' -f1 | tr '[:lower:]' '[:upper:]')

    case "$ver" in
        "3.1"|"4.0"|"4.0.0"|"5.0(PRE)")
            echo "4.0"
            ;;
        "4.0(SP1)"|"5.0")
            echo "tiger"
            ;;
        *)
            echo ""
            ;;
    esac
}

get_repourl $confile
if [ ! -f "$file" ]; then
    repo=$(getRepobyVer)
    echo "deb [ trusted=yes ] https://${repoUrl}/nfscdos 3.0 softwarecenter drivecenter depend $repo" > $file

    if [ "4.0" = "$repo" ]; then
        sed -i "/^deb/ s/https:/http:/" $file
    fi
fi

retry=0
while [ $retry -lt 5 ] # 失败重试5次
do
    apt-get update
    # 忽略apt update的返回值(忽略其他源同步失败), 只要软件中心的源同步成功就行
    cnt=$(ls -l /var/lib/apt/lists/${repoUrl}_*_Release | wc -l)
    if [ $cnt -gt 0 ]; then
        break
    fi

    retry=$(($retry+1))
    echo "apt-get update failed, retry later..."
    sleep 15
done
